<?php
/*******************************************************************************
**                                                                            **
** Birdcap - customized release for Bernhard Vogl                             **
** ==============================================                             **
**                                                                            **
** installation: just copy this to your webserver. ready to work              **
**                                                                            **
** usage: birdcap.php?pano=XXX.htm                                            **
**        where XXX.htm is a valid html file                                  **
**                                                                            **
** result: if SPi-V is present, calls the script convert2.php?file=XXX.htm    **
**         else, if QuickTime is present, calls XXX.htm directly              **
**         else, if DevalVR is present, calls convert2deval.php?file=XXX.htm  **
**         and if none is present, sends the user to a download/explanation   **
**         page called plugins.htm                                            **
**         if brocap server is offline, displays SPi-V                        **
**                                                                            **
** for PHP coders: changes to the above behaviour can be implemented in the   **
**                 Birdcap section at the end of this file                    **
**                 and in the customizeable variables at the end of the doc   **
**                 section.                                                   **
**                                                                            **
**                                                                            **
** Brocap - release 1.0 - 2006-Mar-04                                         **
** ==================================                                         **
** Change history:                                                            **
**   20060308 viebvo:                                                         **
**     Check if browser capabilities already known:
**       sichergestellt
**     determine the preferred viewer:                                        **
**       "undefiened" exeption bei 'brocap_plugin' behoben                    **
**                                                                            **
**                                                                            **
**                                                                            **
** License                                                                    **
** =======                                                                    **
**                                                                            **
** Copyright (C) 2005-2006 Yuval Levy                                         **
** All rights reserved.                                                       **
**                                                                            **
** The latest version of this software is available at http://br.xenaura.com/ **
**                                                                            **
** Redistribution, use and translation into other languages in source and     **
** binary forms, with or without modification, are permitted provided that    **
** the following conditions are met:                                          **
**                                                                            **
** 1. Redistributions must retain the above copyright notice, this list of    **
**    conditions and the following disclaimer.                                **
**                                                                            **
** 2. Redistributions must include an unchanged version of the original       **
**    distribution files clearly identified as the original distribution.     **
**                                                                            **
** 3. Modifications and translations to this software must be made available  **
**    to Yuval Levy under the same conditions as the original distribution    **
**    for redistribution/modification. Yuval Levy reserves the right to       **
**    include such modifications or translations in future releases, in       **
**    which case credit will be given to the author in the copyright notice.  **
**                                                                            **
** 4. Redistribution must be totally free of charges. Inclusion on CD-ROMs    **
**    or other media that are part of a transaction involving an exchange of  **
**    money require the explicit written consent of Yuval Levy.               **
**                                                                            **
** THIS SOFTWARE IS PROVIDED BY THE AUTHOR 'AS-IS' AND ANY EXPRESS OR IMPLIED **
** WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF       **
** MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.       **
** IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,           **
** INCIDENTAL, SPECIAL, EXEMPLARY, COLLATERAL OR CONSEQUENTIAL DAMAGES        **
** (INCLUDING BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR          **
** SERVICES; LOSS OF USE, DATA, PROFITS, HEALTH OR LIFE; OR BUSINESS          **
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,               **
** WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLICENCE OR    **
** OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN        **
** IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                              **
**                                                                            **
**                                                                            **
** Requirements                                                               **
** ============                                                               **
** Server side: - PHP 4.1.0 or higher                                         **
** 		- usage of standard GET URL delimiters ? and &                        **
**                                                                            **
** Usage                                                                      **
** =====                                                                      **
** 1. Copy this file to your server. A good place to put it is in the         **
**    Document Root.                                                          **
** 2. Customize this file (see customizeable values below).                   **
** 3. Change the file extension of all your .HTML/.HTM pages to .PHP          **
** 4. Add the following line at the beginnig of your PHP pages:               **
**    ?<php include_once('brocap.php');>?                                     **
** 5. prepare the code to display the panorama with the different plug ins    **
** 6. In your php page, at the location where the panorama should display,    **
**    put the following block (with the proper file names and paths and in a  **
**    ?<php>? tag:                                                            **
**                                                                            **
**                                                                            **
**  switch(BROCAP_PLUGIN){                                                    **
**      case 'HAS_JAVA':                                                      **
**              // your java code here                                        **
**              include('pano.ptviewer.htm');                                 **
**              break;                                                        **
**      case 'HAS_QT':                                                        **
**              // your qt code here                                          **
**              include('pano.qt.htm');                                       **
**              break;                                                        **
**      case 'HAS_SHOCKWAVE':                                                 **
**              // your shockwave code here                                   **
**              include('pano.spiv.htm');                                     **
**              break;                                                        **
**      case 'HAS_DEVALVR':                                                   **
**              // your devalvr code here                                     **
**              include('pano.deval.htm');                                    **
**              break;                                                        **
**      default:                                                              **
**              // the default page if no plug in is present                  **
**              include('default.htm');                                       **
**  }                                                                         **
**                                                                            **
**                                                                            **
** Code Comments                                                              **
** =============                                                              **
**                                                                            **
** The above code is very basic. It keeps the code for the individual plugins **
** in separate files. It would also be possible to put the code directly      **
** instead of the include command.                                            **
**                                                                            **
** A more refined approach, e.g. different behaviour for default=no plugin    **
** available (a certainty) and default=no brocap available (plugin potentially**
** present) is possible with a little PHP skills.                             **
**                                                                            **
** Also not in this basic code is the user override of the system detection.  **
**                                                                            **
** Alternatively, you can test each plug in individually with the PHP         **
** defined function, and use the other constants defined by brocap in PHP.    **
** PHP programming skills required.                                           **
**                                                                            **
** To avoid repeat testing for cookie-refusniks it is adviseable to           **
** pass the brocap parameter as a GET variable in the URL of further links    **
** internal to the website.                                                   **
**                                                                            **
** This is PHP specific code. The process could be coded in other server-side **
** languages such as ASP/JPS/ColdFusion/Perl, or in client-side JavaScript.   **
** Feel free to do so if you have the skills.                                 **
** Please contribute the translation back to the project.                     **
**                                                                            **
**                                                                            **
**                                                                            **
** Defined Constants                                                          **
** =================                                                          **
** If a specific plug in is detected, the following constants are set to 1.   **
**                                                                            **
** Constant                           Plugin                                  **
** HAS_JAVA                           Java                                    **
** HAS_QT                             QuickTime                               **
** HAS_FLASH                          Flash                                   **
** HAS_SHOCKWAVE                      ShockWave                               **
** HAS_ACROBAT                        Acrobat Reader                          **
** HAS_SVG_VIEWER                     SVG-Viewer                              **
** HAS_WMP                            Windows Media Player                    **
** HAS_REALPLAYER                     Real Player                             **
** HAS_GLPANOVIEW                     GLPanoView                              **
** HAS_ZOOMIFY                        Zoomify                                 **
** HAS_PANGEAVR                       PangeaVR                                **
** HAS_DEVALVR                        DevalVR                                 **
** HAS_VOLUMEPHOTOVIEWER              VolumePhotoViewer                       **
** HAS_IPIX                           iPix                                    **
**                                                                            **
** SYSTEM_CLASS this code groups systems in four classes:                     **
**              win: Windows Boxes                                            **
**              mac: Macintosh OSX Boxes                                      **
**              oqt: Legacy Macintosh boxes                                   **
**              jav: legacy Windows Boxes, Unix Boxes and other Boxes         **
**                                                                            **
** BROCAP_PLUGIN contains the name of the constant associated with the        **
**               preferred plugin.                                            **
**                                                                            **
** The philosophy behind this is that for panorama display each of these      **
** classes can be treated differently: win and mac are assumed to be modern   **
** powerful machines. Most of them have 3D acceleration and a wealth of       **
** plug ins to choose from.                                                   **
** For older machines, QuickTime is a safe choice with Mac and Java with Win  **
** There are seldom Linux/Unix Boxes with 3D acceleration enabled, hence they **
** are classified, with other unknown machines, in the jav category where     **
** java might be present and the machines are likely to be not so powerful    **
** (like WindowsCE, Java-enabled cell phones, and other devices).             **
**                                                                            **
** SCREEN_WIDTH, SCREEN_HEIGHT in pixels or 0 if not detected.                **
** SCREEN_DEPT: the color depth, in bits or 0 if not detected.                **
**                                                                            **
**                                                                            **
** Customizeable values                                                       **
** ====================                                                       **
** MAX_BROCAP_LIFE is the maximum lifespan validity of the brocap test.       **
**                 default value is 3600 seconds, i.e. the brocap test is     **
**                 valid for one hour, so that if the brocap result is        **
**                 bookmarked or otherwise accidentally stored in a link,     **
**                 it will not turn stale. increase this value to test        **
**                 less frequently. reduce it to test more frequently.        **
** MAX_BROCAP_TIMEOUT is the maximum time in second to wait for a reply from  **
**                    the brocap server before assuming that it is offline.   **
**                    default value is 10 seconds, i.e. if after 10 seconds   **
**                    there is no response, move on as if brocap does not     **
**                    exist. A too small value can result in false positives. **
** BROCAP_UNAVAILABLE TIME is the time in seconds to wait before retrying to  **
**                         do the brocap if it was not available. Default is  **
**                         600 seconds. A lower value may result in degraded  **
**                         user experience.                                   **
** $plugprio array: for each of the defined system classes, list the constant **
**                  for the plugins that you want to use in order of          **
**                  descending priority                                       **
**                  The default value will display SPi-V/Shockwave first,     **
**                  then DevalVR, Java and QuickTime on modern PCs and Macs.  **
**                  It will display QuickTime first on legacy Macs.           **
**                  It will display Java first, then DevalVR and QuickTime    **
**                  on all other boxes.                                       **
**                  SEQUENCES/PRIORITIES MODIFIED FOR BERNHARD VOGL           **
** $seofilter array: an array of IP ranges for which no capabilities test     **
**                   will be requested (e.g. search engines).                 ** 
**                   the range is defined by the two IP addresses in 'from'   **
**                   and 'to' which are included in the range.                **
**                   To include further IP ranges, just copy one $seofilter[] **
**                   line and enter a new from/to IP range.                   **
**                                                                            **
*******************************************************************************/
define('MAX_BROCAP_LIFE',3600);
define('MAX_BROCAP_TIMEOUT',10);
define('BROCAP_UNAVAILABLE_TIME',600);
$plugprio['win']='HAS_QT,HAS_DEVALVR,HAS_SHOCKWAVE,HAS_FLASH';
$plugprio['mac']='HAS_QT,HAS_PANGEAVR,HAS_SHOCKWAVE,HAS_FLASH,HAS_DEVALVR';
$plugprio['oqt']='HAS_QT,HAS_DEVALVR,HAS_SHOCKWAVE';
$plugprio['jav']='HAS_QT,HAS_DEVALVR,HAS_SHOCKWAVE';
// the localhost, in case you are testing this locally
$seofilter[]=array('from' => '127.0.0.1','to'=> '127.0.0.1');
// Yuval's IP, for testing purposes
$seofilter[]=array('from' => '69.159.136.244', 'to' => '69.159.136.244');
/*******************************************************************************
** DO NOT CHANGE THE CODE BELOW THIS LINE.                                    **
** you can and want to change the code at the end of this file in the         **
** birdcap section.                                                           **
*******************************************************************************/
/*******************************************************************************
** Check if browser capabilities already known                                **
*******************************************************************************/
if(isset($_COOKIE['brocap'])){
	// if we have brocap in the cookie, take it
	$tempbrocap=$_COOKIE['brocap'];
}elseif(isset($_GET['brocap'])){
	// if we have brocap in GET request, either because this is the return from the test,
	// or this is a cookie-refusnik, take it as well.
	$tempbrocap=$_GET['brocap'];
}
// current time
$t=time();
// make some verifications on the brocap cookie
if(isset($tempbrocap)){
	// echo "md5 - has the brocap string become corrupted in transmission?";
	$md5=substr($tempbrocap,-32);
	$cap=substr($tempbrocap,0,-32);
	if(md5($cap)!=$md5){
		// echo "wrong md5 - tampered brocap, request a new one";
		$brocap_request=1;
	}
	// echo "check the timestamp to make sure this is fresh enough and not the result of a bookmark or a link";
	$brocap_time=substr($cap,-10,10);
	$cap=substr($cap,0,-10);
	if(($t-$brocap_time)>MAX_BROCAP_LIFE){
		// echo "request a new test";
		$brocap_request=1;
	// 20060308 bvogl: Wenn $tempbrocap gesetzt und gltig ist, darf kein
	//                 brocap_request mehr erfolgen, sonst brocap loop
	//                 Muss explizit definiert werden, sonst exeption
	} else {
	  $brocap_request=0;
	}
}else{
	// echo "no brocap, request a new one";
	$brocap_request=1;
}

// Clean check
//echo $tempbrocap,"<br>",$brocap_request;


/*******************************************************************************
** Check if the IP address is in a filtered range for which we do not want    **
** a test                                                                     **
*******************************************************************************/
if(is_array($seofilter)){
	$r=sprintf('%u',ip2long($_SERVER['REMOTE_ADDR']));
	reset($seofilter);
	while(list($k,$v)=each($seofilter)){
		$f=sprintf('%u',ip2long($v['from']));
		$o=sprintf('%u',ip2long($v['to']));
		if(($r<=$o)&&($r>=$f)){
			// the IP address is in an identified range
			// do not request brocap
			$brocap_request=0;
			define('BROCAP_PLUGIN','IS_SE');
		}
	}
}
/*******************************************************************************
** No detection required if we know the preferred plugin                      **
*******************************************************************************/
if(isset($_COOKIE['brocap'])){
	$brocap_request=0;
}
/*******************************************************************************
** Kick Off Detection of browser capabilities                                 **
*******************************************************************************/
if(1==$brocap_request){
	// check if the brocap server is alive
	$brocap_server=@fsockopen("br.xenaura.com", 80,$errno,$errstr,MAX_BROCAP_TIMEOUT);
	if(!($brocap_server)){
		// no connection to the server before the time out
		$brocap='NOSERVER';
	}else{
		// close cleanly the connection
		$brocap_out = "GET / HTTP/1.1\r\n";
		$brocap_out.= "Host: br.xenaura.com\r\n";
		$brocap_out.= "Connection: Close\r\n\r\n";
		fwrite($brocap_server, $brocap_out);
		fclose($brocap_server);
		// this is the URL to which we want the user to come back after the test
		$brocap_myURL='http://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'];
		$brocap_t=urlencode($brocap_myURL);
		// send the user to the test engine
		header('Location: http://br.xenaura.com/brcp_d.php?trgt='.$brocap_t.'&time='.$t);
		exit();
	}
}
if(isset($tempbrocap)){
	// brocap is ok, move from temporary to stable
	$brocap=$tempbrocap;
}
/*******************************************************************************
** Interpretation of browser capabilities                                     **
*******************************************************************************/
// interpret brocap
if(isset($brocap)){
	if('NOSERVER'==$brocap){
		if(!(isset($_COOKIE['brocap']))){
			// set brocap cookie temporary until we try again if the server is there
			setcookie('brocap', $brocap, time()+BROCAP_UNAVAILABLE_TIME);
		}
		$brocap='';
		define('BROCAP_PLUGIN','NOSERVER');
	}else{
		// or for the whole session if it was
		setcookie('brocap',$brocap);
	}
	if(substr($brocap,0,1)!='_'){
		define('HAS_JAVA',1);
	}
	if(substr($brocap,1,1)!='_'){
		define('HAS_QT',1);
	}
/* just Flash detection
	if(substr($brocap,2,1)!='_'){
		define('HAS_FLASH',1);
	}

	Flash>=8
*/
	if(strtolower(substr($brocap,2,1))>'g'){
     define('HAS_FLASH',1);
	}
	if(substr($brocap,3,1)!='_'){
		define('HAS_SHOCKWAVE',1);
	}
	if(substr($brocap,4,1)!='_'){
		define('HAS_ACROBAT',1);
	}
	if(substr($brocap,5,1)!='_'){
		define('HAS_SVG_VIEWER',1);
	}
	if(substr($brocap,6,1)!='_'){
		define('HAS_WMP',1);
	}
	if(substr($brocap,7,1)!='_'){
		define('HAS_REALPLAYER',1);
	}
	if(substr($brocap,8,1)!='_'){
		define('HAS_GLPANOVIEW',1);
		}
	if(substr($brocap,9,1)!='_'){
		define('HAS_ZOOMIFY',1);
	}
	if(substr($brocap,10,1)!='_'){
		define('HAS_PANGEAVR',1);
	}
	if(substr($brocap,11,1)!='_'){
		define('HAS_DEVALVR',1);
	}
	if(substr($brocap,12,1)!='_'){
		define('HAS_VOLUMEPHOTOVIEWER',1);
	}
	if(substr($brocap,13,1)!='_'){
		define('HAS_IPIX',1);
	}
	// system class
	switch(substr($brocap,14,1)){
		// win
		case 'b':
		case 'w':
			define('SYSTEM_CLASS','win');
			break;
		// mac
		case 'a':
		case 'x':
			define('SYSTEM_CLASS','mac');
			break;
		// legacy mac
		case 'm':
			define('SYSTEM_CLASS','oqt');
			break;
		// legacy win and other systems
		default:
			define('SYSTEM_CLASS','jav');
	}
	// screen resolution
	$screen=substr($brocap,15,20);
	// remove padding
	$screen=trim($screen,'_');
	// convert URL safe to original base64
	$replace=array('+','/','=');
	$find=array('-','_','@');
	$screen=base64_decode(str_replace($find,$replace,$screen));
	$sx=explode('X',$screen);
	// define screen
	define('SCREEN_WIDTH',$sx[0]);
	define('SCREEN_HEIGHT',$sx[1]);
	define('SCREEN_DEPTH',$sx[2]);
}
// default screen information if we could not identify them
if(!(defined('SCREEN_WIDTH'))){define('SCREEN_WIDTH',0);}
if(!(defined('SCREEN_HEIGHT'))){define('SCREEN_HEIGHT',0);}
if(!(defined('SCREEN_DEPTH'))){define('SCREEN_DEPTH',0);}
// default system class
if(!(defined('SYSTEM_CLASS'))){define('SYSTEM_CLASS','jav');}
/*******************************************************************************
** determine the preferred viewer                                             **
*******************************************************************************/
// 20060308 bvogl: An dieser Stelle kann das Cookie 'brocap_plugin' noch
//                 undefined sein. Also erst selbiges pruefen.
if(isset($_COOKIE['brocap_plugin'])){
  if($_COOKIE['brocap_plugin']){
	define('BROCAP_PLUGIN',$_COOKIE['brocap_plugin']);
	// extend cookie validity for a year
	setcookie('brocap_plugin',BROCAP_PLUGIN,time()+3500);
  }
}else{
	$prio = explode(',', $plugprio[SYSTEM_CLASS]);
	reset($prio);
	while(list($k,$v)=each($prio)){
		if(defined($v)){
			define('BROCAP_PLUGIN',$v);
			break;
		}
	}
}
/*******************************************************************************
** birdcap                                                                    **
*******************************************************************************/
$pano=$_GET['pano'];
switch(BROCAP_PLUGIN){
	// if it is a filtered search engine, show the standard quicktime page
	case 'IS_SE':
	// detected QT
	case 'HAS_QT':
		header('Location: convert2.php?format=qtvr&file='.$pano);
		exit();
		break;
	// detected SW
	case 'HAS_SHOCKWAVE':
		header('Location: convert2.php?format=spiv&file='.$pano);
		exit();
		break;
	// detected devalVR
	case 'HAS_DEVALVR':
		header('Location: convert2.php?format=devr&file='.$pano);
		exit();
		break;
	// detected PangeaVR
	case 'HAS_PANGEAVR':
		header('Location: convert2.php?format=pangea&file='.$pano);
		exit();
		break;
	// detected Flash
	case 'HAS_FLASH':
		header('Location: convert2.php?format=flash&file='.$pano);
		exit();
		break;
	// no detection possible
	case 'NOSERVER':
	// detected no plug in available
	default:
		header('Location: cp.php?file='.$pano);
		exit();
}
?>
